//
// Created by imanol on 12/25/16.
//

#ifndef SYNACORVM_CPU_H
#define SYNACORVM_CPU_H

#include <stdio.h>
#include "mem.h"
#include "stack.h"
#include "registers.h"

#define MAX_INT 32767

#define HALT    0x0000
#define MOV     0x0001
#define PUSH    0x0002
#define POP     0x0003
#define TEQ     0x0004
#define TGT     0x0005
#define JMP     0x0006
#define JNZ     0x0007
#define JZ      0x0008
#define ADD     0x0009
#define MULT    0x000A
#define MOD     0x000B
#define AND     0x000C
#define OR      0x000D
#define NOT     0x000E
#define LOAD    0x000F
#define STOR    0x0010
#define CALL    0x0011
#define RET     0x0012
#define OUT     0x0013
#define IN      0x0014
#define NOP     0x0015


void start_execution();
void core_dump();

#endif //SYNACORVM_CPU_H
