//
// Created by imanol on 12/25/16.
//

#include <malloc.h>
#include "stack.h"

#define EXTEND_SIZE 10

uint8_t STACK_FAULT = 0;
uint32_t stack_size = EXTEND_SIZE;
uint32_t stack_pos = 0;
short *stack;

void initialize_stack()
{
    stack = calloc(EXTEND_SIZE,sizeof(short));
}

void free_stack()
{
    free(stack);
    stack_size = 0;
    stack_pos = 0;
    stack = NULL;
}

void extend_stack()
{
    stack_size += EXTEND_SIZE;
    void *new_ptr = realloc(stack,stack_size*sizeof(short));
    if(new_ptr == NULL)
    {
        fprintf(stderr,"CRITICAL: STACK ALLOCATION ERROR\n");
        core_dump();
    }
    stack = new_ptr;
}

void shrink_stack()
{
    stack_size -= EXTEND_SIZE;
    void *new_ptr = realloc(stack,stack_size*sizeof(short));
    if(new_ptr == NULL)
    {
        fprintf(stderr,"CRITICAL: STACK ALLOCATION ERROR\n");
        core_dump();
    }
    stack = new_ptr;
}

void stack_push(short value)
{
    stack[stack_pos++] = value;
    if(stack_pos == stack_size-1)
    {
        extend_stack();
    }
}

short stack_pop()
{
    if(!stack_pos)
    {
        STACK_FAULT = 1;
        return -1;
    }
    short value = stack[stack_pos--];
    if(stack_size - stack_pos == 2*EXTEND_SIZE)
    {
        shrink_stack();
    }
    return value;
}

